##########################################################################
#                                                                        #
# COLLATINUS - interface                                                 #
#    lemmatiseur et analyseur morphologique                              #
#    pour la langue latine                                               #
# Yves Ouvrard, avril 2002                                               #
# yves.ouvrard@ac-poitiers.fr                                            #
#                                                                        #
# Cette application est place sous licence GPL (General Public License) #
# dont une copie est et doit rester incluse  ce paquetage.              #
#                                                                        #
##########################################################################

from  collat import lemmes, chaineAnalyse
from  Tkinter  import  *
from ScrolledText import *
from Separator import *
from tkFileDialog import *
import tkMessageBox
import fileinput
import  sys
import string
import re

root  =  Tk()
root.geometry("400x400+50+50")

separateur = VSeparator(root, bg="red")
memoL = ScrolledText(separateur.f1, width=60, height=10, wrap='word')
memoL.pack(fill=BOTH, expand=1)
memoF = ScrolledText(separateur.f2, width=60, height=7)
memoF.pack(fill=BOTH, expand=1)

tableau = {}    

def  quitter():
        sys.exit()

def viderL():
    memoL.delete(0.1, END)

def viderF():
    memoF.delete(0.1, END)    
    
def vider():
    viderL()
    viderF()

def analyse():
    global tableau
    viderF()
    for i in range(len(tableau)):
	if tableau[i] > '':
		memoF.insert(END, lemmes(tableau[i]))

def analyseM():
    global tableau
    viderF()
    for i in range(len(tableau)):
	if tableau[i] > '':
	        memoF.insert(END, chaineAnalyse(tableau[i]))        

def choix_fichier():
    pl = END
    global tableau
    oname = askopenfilename(filetypes=[("fichiers texte (*.txt)", "*.txt")])
    if oname:
        vider()
        for line in fileinput.input(oname):
            memoL.insert(pl,line)
        p = re.compile(r'\W')
        chaine = memoL.get(0.1, END)
        tableau = p.split(chaine)
         

def sauver():
    snom = asksaveasfilename(filetypes=[("fichiers texte", "*.txt")])
    if snom:
        ofp = open(snom,"w")
        ofp.write(memoL.get(1.0,END))
        ofp.write(" --- \n");
        ofp.write(memoF.get(1.0,END))
        ofp.flush()
        ofp.close()

def apropos():
    tkMessageBox.showinfo("Collatinus",
	"Lemmatiseur et analyseur morphologique\n"
        "pour le latin, version 1.0.0.b\n"
        "mars 2002\n"
        "Yves Ouvrard - Licence GPL")

barre  =  Menu(root)

# boutons de menu
menu_fichier  =  Menu(barre,tearoff=0)
menu_fichier.add_command(label="Ouvrir...",command  =  choix_fichier)
menu_fichier.add_command(label="Nouveau...",command  =  vider)
menu_fichier.add_command(label="Sauver...",command  =  sauver)
menu_fichier.add_separator()
menu_fichier.add_command(label="Quitter...",command  =  quitter)

menu_Analyse = Menu(barre, tearoff=0)
menu_Analyse.add_command(label="Lexique", command = analyse)
menu_Analyse.add_command(label="Lexique et morphologie", command = analyseM)

menu_Apropos = Menu(barre, tearoff=0)
menu_Apropos.add_command(label="A propos", command = apropos)

# barre  de  Menu
barre.add_cascade(label  =  "Fichier",menu=menu_fichier)
barre.add_cascade(label  =  "Analyse",menu=menu_Analyse)
barre.add_cascade(label  =  "A propos",menu=menu_Apropos)

root.config(menu=barre)
root.mainloop()
